#include "../Helper/helperInclude.hpp"



void runSequences(vector<string> sequences = {}) {

	Log::setLevel(0);

	string datasetPath = "C:/VOT2014WD/sequences/";
	string outFile = "F:/Value/Personal/Parthenope/Project/input/babenko/VOTChallenge/_outputBDF/vot2014.txt";

	if (sequences.empty()) {

		sequences = {
			"ball",
			"basketball",
			"bicycle",
			"bolt",
			"car",
			"david",
			"diving",
			"drunk",
			"fernando",
			"fish1",
			"fish2",
			"gymnastics",
			"hand1",
			"hand2",
			"jogging",
			"motocross",
			"polarbear",
			"skating",
			"sphere",
			"sunshade",
			"surfing",
			"torus",
			"trellis",
			"tunnel",
			"woman"
		};

	}

	vector<float> datasetAccuracy;

	fileAppend(outFile, "\n\n\n\n\n=====NEW RUN (accuracy)=====\n\n");

	for (auto& name : sequences) {

		Ptr<BDF> tracker = new BDF();
		tracker->openDataset(datasetPath + name + "/");

		float accuracy = tracker->run();

		datasetAccuracy.push_back(accuracy);
		fileAppend(outFile, name + ": " + toString(accuracy) + "\n");
		waitKey(100);
	}

	for (auto i = 0; i < datasetAccuracy.size(); i++){
		cout << sequences[i]<< " accuracy: " << datasetAccuracy[i] << endl;
	}

	string end = "\n===== FINAL MEAN ACCURACY: " + toString(meanVector<float>(datasetAccuracy))+ ", over " + toString(datasetAccuracy.size()) + " datasets\n";
	cout << end;
	fileAppend(outFile, end);

	sp();
}



int main() {

	
	
	runVOT(new BDF());return 0;

	//runSequences(big);return;
	
	// fish1, starts from 128
	
	Log::setLevel(1);
	BDF myTracker;
	myTracker.openDataset("C:/VOT2014WD/sequences/fish2/");
	
	myTracker.run(0);
	
	sp();
	return 0;
	


	
	// size testing
	Log::setLevel(0);
	
	map<int, float> patchAccuracy;
	for(int i=7;i<20;i++) {

		float acc;
		
		{

			BDF myTracker;
			myTracker.openDataset("C:/VOT2014WD/sequences/hand2/");

			myTracker.trackerSizes.push_back(7);	myTracker.trackerSpaces.push_back(2);
			myTracker.trackerSizes.push_back(10);	myTracker.trackerSpaces.push_back(-5);
			myTracker.trackerSizes.push_back(14);	myTracker.trackerSpaces.push_back(0);

			myTracker.trackerSizes.push_back(i);
			myTracker.trackerSpaces.push_back(- i/2);

			acc = myTracker.run();

		}
		patchAccuracy[i] = acc;
		/*
		{
			BDF myTracker;
			myTracker.openDataset("C:/VOT2014WD/sequences/hand2/");

			myTracker.trackerSizes.push_back(7); myTracker.trackerSpaces.push_back(2);
			myTracker.trackerSizes.push_back(10); myTracker.trackerSpaces.push_back(-5);

			myTracker.trackerSizes.push_back(i);
			myTracker.trackerSpaces.push_back(-2);

			acc = myTracker.run();
		}
		patchAccuracy[i] += acc;
		*/


		cout << "With patchSize: " << i << ", accuracy: " << acc << endl;
	}
	cout << "Summary:" << endl;
	for (auto acc : patchAccuracy) {
		cout << "With patchSize: " << acc.first << ", accuracy: " << acc.second << endl;
	}
	
	
	sp();

}

