#include "Matrioska/MatrioskaHeader.hpp"

class SimpleTracker : public Tracker {

		
public:
	void track(){

		this->prepare();


		if (frameCount == 1) {

			objectROI = firstBB;

			rectInsideImage(currentFrame, firstBB);
			objectTemplate = currentFrame(firstBB).clone();			
			//showImage(objectTemplate, "Template");

			enlarageSearchWindow = max(firstBB.width,firstBB.height);

			return;
		}

		Rect searchWindow = rectSum2(objectROI, enlarageSearchWindow);
		rectInsideImage(currentFrame, searchWindow);
		drawRect(frame, searchWindow, Scalar(0, 0, 255));	//> Draw search window

		Mat result;
		matchTemplate(currentFrame(searchWindow), objectTemplate, result, CV_TM_CCOEFF_NORMED);

		//> Localizing the best match with minMaxLoc
		double minVal, maxVal;
		Point minLoc, maxLoc, matchLoc;

		minMaxLoc(result, &minVal, &maxVal, &minLoc, &maxLoc, Mat());
		matchLoc = maxLoc;

		Point topLeft = matchLoc;
		matchLoc = Point(matchLoc.x + searchWindow.x, matchLoc.y + searchWindow.y);
		objectROI = Rect(matchLoc.x, matchLoc.y, objectTemplate.size().width, objectTemplate.size().height);

		rectInsideImage(currentFrame, objectROI);
		isObjectFound = true;

		if (frameCount%5==0)
			objectTemplate = currentFrame(objectROI).clone();
	}

private:
	Mat objectTemplate;
	int enlarageSearchWindow;
};

void main(){

	//runVOT(new SimpleTracker());
	//return;

	SimpleTracker tracker;
	tracker.openDataset("C:/VOT2014WD/sequences/torus/");
	tracker.run();

	sp();
}