void singleRecognition() {
	setConfig();

	vector<Mat> objects;
	vector<vector<KeyPoint>> objectKp;
	vector<Mat> objectDesc;
	
	
	for(int i=0;i<inputPaths.size();i++) {

		
		Mat object = loadImage(inputPaths.at(i),CV_LOAD_IMAGE_GRAYSCALE);
	
		//> Image
		objects.push_back(object);

		//> Keypoint
		vector<KeyPoint> kpObjectCurrent;
		objectDesc.push_back(feature(object,kpObjectCurrent));

		//>Keypoint
		objectKp.push_back(kpObjectCurrent);
	}


	sp();
	cout << "Starting Object Recognition" << endl << "--------------"<<endl;

	

	//> Get the corners from the object
	vector<vector<Point2f>> objCorners;
	for(int i=0;i<objects.size();i++) {
		objCorners.push_back(vector<Point2f>());
		objCorners[i].push_back(Point2f(0,0));
		objCorners[i].push_back(Point2f( objects[i].cols, 0 ));
		objCorners[i].push_back(Point2f( objects[i].cols, objects[i].rows ));
		objCorners[i].push_back(Point2f( 0, objects[i].rows ));
	}

	VideoCapture cap(0);

	cap.set(CV_CAP_PROP_FRAME_WIDTH,cameraWidth);
	cap.set(CV_CAP_PROP_FRAME_HEIGHT,cameraHeight);

    
	
	char key = 'a';
    int framecount = 0;

	clock_t start;
	clock_t startFrame = profileStart();

	 while (key != 27) {

        Mat frame;
		cap >> frame;
		framecount++;
        if (framecount < 5)    
            continue;
		
		//frame = imread( "D:/Value/Personal/Parthenope/Project/input/test1.jpg", CV_LOAD_IMAGE_COLOR );


		cout << endl << endl<<"Frame #"<<framecount<<endl;
		
		Mat queryImage;
		cvtColor(frame, queryImage, CV_RGB2GRAY);
		//queryImage = frame;

        vector<KeyPoint> queryKp;
		Mat queryDesc;  

        vector<Point2f> obj;	
        vector<Point2f> scene;
        vector<Point2f> sceneCorners(4);

        Mat H;
        

		queryDesc = feature(queryImage,queryKp);

		vector<DMatch> goodMatches;
		bool matched = false;
		int objectIndex = 0;
		for(int i=0;i<objectDesc.size();i++) {

			goodMatches = match(objectDesc[i],queryDesc);
			

			if (goodMatches.size() > goodMatchCount) {
				objectIndex=i;
				matched = true;
				break;
			}

		}

		//> Erase goodMatches if not found
		if (!matched)
			goodMatches.clear();





		Mat imageMatched;
		vector<DMatch> goodMatches2;
        //Draw only "good" matches
		drawMatches(frame, 	queryKp, 
					 objects[objectIndex], objectKp[objectIndex], 
					goodMatches2,imageMatched, 
					Scalar(255,255,255), Scalar::all(-1), vector<char>(), 
					DrawMatchesFlags::NOT_DRAW_SINGLE_POINTS );

        if (matched) {

			start = profileStart();

            for( int i = 0; i < goodMatches.size() ; i++ ){
                //Get the keypoints from the good matches
                obj.push_back( objectKp[objectIndex][ goodMatches[i].trainIdx ].pt );
                scene.push_back( queryKp[ goodMatches[i].queryIdx ].pt );
            }

            H = findHomography( obj, scene, CV_RANSAC );
            perspectiveTransform( objCorners[objectIndex], sceneCorners, H);

			profileDebug(start,"Homography");

            //Draw lines between the corners of the object in the query image )
            line( imageMatched, sceneCorners[0] , sceneCorners[1] , Scalar(0, 255, 0), 4 );
            line( imageMatched, sceneCorners[1] , sceneCorners[2] , Scalar( 0, 255, 0), 4 );
            line( imageMatched, sceneCorners[2] , sceneCorners[3] , Scalar( 0, 255, 0), 4 );
            line( imageMatched, sceneCorners[3] , sceneCorners[0] , Scalar( 0, 255, 0), 4 );
			


        }

		startFrame = profileDebug(startFrame,"Frame total");

        //Show detected matches
        imshow( "Maresca RTOR", imageMatched );

        key = waitKey(1);
		//> Pausing
		if (key=='p') { 
			cout <<endl<<"------"<< "Paused" << endl;
			waitKey();
		}
    }

}
